
local ObjectivesBackdrop = {                         
	bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
        	edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
        	tile = true, 
        	tileSize = 16, 
        	edgeSize = 16, 
        	insets = { left = 4, right = 4, top = 4, bottom = 4 }
        	};                       

--[[
local ObjectivesTextures = {
        	normal = "Interface\\Buttons\\UI-Panel-Button-Up",
        	pushed = "Interface\\Buttons\\UI-Panel-Button-Down",
        	highlight = "Interface\\Buttons\\UI-Panel-Button-Highlight",
        	disabled = "Interface\\Buttons\\UI-Panel-Button-Disabled",
        	coords = { x1 = 0.0, y1 = 0.625, x2 = 0.0, y2 = 0.6875 },
        	blend = "ADD"
        	};
--]]

local ObjectivesBackcolor = { 
        	red=0,green=0,blue=0,alpha=1 
        	};

local ObjectivesBordercolor = { 
        	red=255,green=255,blue=0,alpha=1 
        	}; 

local WatchFrameScrollFrame;

local function ResetWatchFrame(parent)
	
	nUI_Movers:lockFrame( WatchFrame, false, nil ); -- OBJECTIVES_TRACKER_LABEL );
	nUI_Options.movedWatchFrame = true;

	WatchFrame.moving = true;
	WatchFrame.sizing = true;
	
	WatchFrame:SetMovable( true );
	WatchFrame:SetResizable( true );
	WatchFrame:StartMoving();
	WatchFrame:StartSizing( "TOPLEFT" );
	
	WatchFrame:ClearAllPoints();
	WatchFrame:SetParent(parent);
	WatchFrame:SetPoint( "TOPLEFT", parent, "TOPLEFT", 30,-10 );
	WatchFrame:SetHeight( 500 );
	WatchFrame:SetWidth( parent:GetWidth() );

	WatchFrame.moving = nil;
	WatchFrame.sizing = nil;

	WATCHFRAME_IGNORECURSOR = "1";			
	WATCHFRAME_LASTWIDTH    = parent:GetWidth() ;
	
	WatchFrame:StopMovingOrSizing();
	WatchFrame:SetUserPlaced( true );
	WatchFrame_Expand( WatchFrame );

	nUI_Movers:lockFrame( WatchFrame, true, nil );
end

-- Frame is moving
local function OnMouseDown(self)
	if ( ( not self.isLocked ) or ( self.isLocked == 0 ) ) then
        self:StartMoving();
        self.isMoving = true;
		ResetWatchFrame(WatchFrameScrollFrame.Child);
	end
end

-- Frame has stopped moving
local function OnMouseUp(self)
	if ( self.isMoving ) then
		self:StopMovingOrSizing();
		self.isMoving = false;
		ResetWatchFrame(WatchFrameScrollFrame.Child);
	end
end

-- Frame has been hidden
local function OnHide(self)
	if ( self.isMoving ) then
		self:StopMovingOrSizing();
		self.isMoving = false;
	end
end

local function CreateScrollFrame()
	
	local f = CreateFrame( "Frame", "WatchFrame_Container",UIParent);
	f:SetWidth(400);
	f:SetHeight(200);
	f:SetClampedToScreen(true);
	f:SetFrameStrata("HIGH");
	f:SetPoint("CENTER",UIParent,"CENTER",0,0);
	f:SetBackdrop(ObjectivesBackdrop);
	f:SetBackdropColor(ObjectivesBackcolor.red,ObjectivesBackcolor.green,ObjectivesBackcolor.blue, ObjectivesBackcolor.alpha);
	f:SetBackdropBorderColor(ObjectivesBordercolor.red, ObjectivesBordercolor.green,ObjectivesBordercolor.blue, ObjectivesBordercolor.alpha);
	f:RegisterForDrag("LeftButton");
	f:EnableMouse(true);
	f:SetMovable(true);
	f:SetScript("OnMouseDown",OnMouseDown);
	f:SetScript("OnMouseUp",OnMouseUp);
	f:SetScript("OnHide",OnHide);

	local s = CreateFrame( "ScrollFrame", "WatchFrame_ScrollFrame", f, "UIPanelScrollFrameTemplate" );
	s:SetPoint("TOPLEFT", 5, -5);
	s:SetPoint("BOTTOMRIGHT", -30, 5);
	f.Scroll = s;
	
	local c = CreateFrame("Frame","WatchFrame_ScrollChild",s);
	s:SetScrollChild(c);
	c:SetWidth(2);
	c:SetHeight(2);
	f.Child = c;
		
	return f;
end

local plugin    = CreateFrame( "Frame", "Mini_ObjectiveFrame", UIParent );

local function onEvent()
	if event == "VARIABLES_LOADED" then
		WatchFrameScrollFrame = CreateScrollFrame();
		ResetWatchFrame(WatchFrameScrollFrame.Child);
	end	
end

plugin:SetScript( "OnEvent", onEvent );
plugin:RegisterEvent( "VARIABLES_LOADED" );
